/////////////////  Almostlong_solution.cpp  //////////////

// Que ca-t-il se passer lorsque l'utilisateur va aller cliquer sur le bouton et bouger la fenêtre?

#include <gtkmm/main.h>
#include <gtkmm/button.h>
#include <gtkmm/window.h>
#include <math.h>
#include <limits.h>

#define PI 3.14159265

Gtk::Button *button;

void go() {
	long i=LONG_MIN/100;
	long max= LONG_MAX/100;
	while( i < max ) {
		double result = cos((double)i*PI/180);
		button->set_label( Glib::ustring::compose("done %1%%", (double)i/(double)max) );
		while( Gtk::Main::events_pending()) {
			Gtk::Main::iteration( false );
    }
		i++;
	}
}

int main(int argc, char *argv[])
{
	Gtk::Main kit(argc, argv);
	Gtk::Window win;
	win.set_title("Almost long");
	win.set_border_width(10);
  
	button = new Gtk::Button("Start");
	win.add(*button);
	button->signal_clicked().connect( sigc::ptr_fun(&go) );
  
	button->show();
	Gtk::Main::run(win);
	return 0;
};
