//////////////  Exemple 3 - buttonExample3.cpp  //////////////

// Prévoir le comportement de ce programme ?

#include <gtkmm/main.h>
#include <gtkmm/button.h>
#include <gtkmm/window.h>

class myButton : public Gtk::Button
{
  public:
    myButton(){};
    virtual ~myButton(){};

  public:
    void on_button_enter();

    //Surcharge du callback (ici, la fonction n'a pas été mise en protected volontairement pour cet exemple)
    virtual void on_clicked();
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);

  Gtk::Window win;
  win.set_title("buttonExample 3 - ");
  win.set_border_width(10);
  
  myButton button;
  button.set_label("Cliquez SVP");
  win.add(button);
  
  button.signal_enter().connect( sigc::mem_fun(button, &myButton::on_button_enter) );
  button.signal_enter().connect( sigc::mem_fun(button, &myButton::on_clicked) );
  
  button.show();
  
  Gtk::Main::run(win);

  return 0;
};

void myButton::on_button_enter()
{
  printf("enter!\n");
  on_clicked();
};

void myButton::on_clicked()
{
  printf("Click!\n");
};


