
/////////////////  Exemple 4 - buttonExample_dynamicdisconnection.cpp  ///////////////////

#include <iostream>
#include <list>
#include <gtkmm/main.h>
#include <gtkmm/button.h>
#include <gtkmm/window.h>
#include <gtkmm/box.h>


sigc::connection connexion;
Gtk::Button *button_test, *button;	//< ici, car doit être visible dans la fonction toggle_connection(), et on doit mettre des pointeur pour créer les objets dans le main !
bool connected;


void test_connection() {
	std::cout << "connected"<< std::endl;
};

void toggle_connection() {
	if( !connected ) {
		connexion = button_test->signal_clicked().connect( sigc::ptr_fun( &test_connection ) );
		button->set_label("disconnect");
	} else {
		connexion.disconnect();
		button->set_label("connect");
	}
	connected = !connected;
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);

  Gtk::Window win;
  win.set_title("Dynamic (dis)connection");
  win.set_border_width(10);
  connected=false;
  
  Gtk::VBox box;
button_test=new Gtk::Button("");
button=new Gtk::Button();

  button->set_label("connect");
  button_test->set_label( Glib::ustring("Suis-je connecté ?") );
  box.pack_start(*button);
  box.pack_start(*button_test);
  win.add(box);
  box.show_all();

  button->signal_clicked().connect( sigc::ptr_fun( &toggle_connection ) );
  
  Gtk::Main::run(win);

  return 0;
};


