//////////  Exemple 1 - buttonExample.cpp ////////////

#include <gtkmm/main.h>
#include <gtkmm/button.h>
#include <gtkmm/window.h>

class myButton : public Gtk::Button
{
  public:
    myButton(){};
    virtual ~myButton(){};

  protected:
    //Surcharge du handler :
    virtual void on_clicked();
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);

  Gtk::Window win;
  win.set_title("buttonExample");
  win.set_border_width(10);
  
  myButton button;
  win.add(button);
  button.show();
  
  Gtk::Main::run(win);

  return 0;
};

void myButton::on_clicked()
{
  printf("Click!\n");
};

