
#include <gtkmm/main.h>
#include <gtkmm/button.h>
#include <gtkmm/window.h>

class myButton : public Gtk::Button
{
  public:
    myButton(){};
    virtual ~myButton(){};

  public:
	  void f1();
	  void f2();
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);

  Gtk::Window win;
  win.set_title("buttonExample Plusieurs callbacks");
  win.set_border_width(10);
  
  myButton button;
  win.add(button);
  
  button.signal_clicked().connect( sigc::mem_fun(button, &myButton::f1) );
  button.signal_clicked().connect( sigc::mem_fun(button, &myButton::f2) );
  
  button.show();
  
  Gtk::Main::run(win);

  return 0;
};

void myButton::f1()
{
  printf("f1 !\n");
};

void myButton::f2()
{
  printf("f2 !\n");
};
