
#include <stdlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <gtkmm.h>
#include <assert.h>
#include <math.h>


using namespace Gtk;

class MonLabel : public Gtk::Label
{
  public:
    MonLabel(){};
    virtual ~MonLabel(){};

  protected:
    virtual bool on_expose_event(GdkEventExpose* event);
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);
  
  Window window;
  
  MonLabel m_label;
  window.add(m_label);
  
  m_label.show();
  
  Gtk::Main::run(window);
  return EXIT_SUCCESS;
};


bool MonLabel::on_expose_event(GdkEventExpose* event)
{
  Glib::RefPtr<Gdk::Window> window = get_window();

  Gtk::Allocation allocation = get_allocation();
  const int width = allocation.get_width();
  const int height = allocation.get_height();
  
  int w,h;
  
  if(window) {
    Cairo::RefPtr<Cairo::Context> cr = window->create_cairo_context();
    assert(cr);
    
    Glib::RefPtr<Pango::Layout> pangoLayout = Pango::Layout::create (cr);
    cr->move_to(20,10);
    pangoLayout->set_font_description( Pango::FontDescription("helvetica bold 20") );
    pangoLayout->set_text("text");
    pangoLayout->update_from_cairo_context(cr);
    pangoLayout->add_to_cairo_context(cr);       //Ajoute le texte à la pile des éléments à dessiner
    
    //Réalisation
    cr->set_source_rgb(0.8,0,0);
    cr->fill();
  }
};

